## lomiri-camera-app 4.0.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(lomiri-camera-app VERSION 4.0.1 LANGUAGES CXX)
set (CMAKE_CXX_STANDARD 11)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

# Standard install paths. Needs to be set before finding packages.
include(GNUInstallDirs)

find_package(Qt5Qml)
find_package(Qt5Quick)
find_package(Qt5Multimedia)
find_package(Qt5Gui)
find_package(Qt5Svg)
find_package(Qt5QuickControls2)

include(FindGettext)
if(NOT GETTEXT_FOUND)
  message(FATAL_ERROR "Could not find gettext")
endif(NOT GETTEXT_FOUND)

option(INSTALL_TESTS "Install the tests on make install" off)
option(CLICK_MODE "Installs to a contained location" on)

set(CAMERA_APP lomiri-camera-app)
set(AUTOPILOT_DIR lomiri_camera_app)
set(DESKTOP_FILE lomiri-camera-app.desktop)
set(READER_APP lomiri-barcode-reader-app)
set(DESKTOP_FILE_READER lomiri-barcode-reader-app.desktop)
set(UBUNTU_MANIFEST_PATH "manifest.json.in" CACHE INTERNAL "Tells QtCreator location and name of the manifest file")
set(CMAKE_VERBOSE_MAKEFILE ON)

if(CLICK_MODE)

    set(CMAKE_INSTALL_PREFIX /)
    set(CAMERA_APP_DIR /)
    set(CMAKE_INSTALL_BINDIR /)
    set(PLUGIN_BASE lib/${CMAKE_LIBRARY_ARCHITECTURE})
    set(PLUGIN_DIR ${PLUGIN_BASE}/CameraApp)
    set(DESKTOP_EXEC "./${CAMERA_APP}")
    set(CAMERA_ICON "${CMAKE_INSTALL_DATADIR}/icons/lomiri-camera-app.svg")
    set(CAMERA_SPLASH "${CMAKE_INSTALL_DATADIR}/icons/lomiri-camera-app-splash.svg")
    install(FILES assets/lomiri-camera-app.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
    install(FILES assets/lomiri-camera-app-splash.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)

    set(READER_ICON "${CMAKE_INSTALL_DATADIR}/icons/lomiri-barcode-reader-app.png")
    set(READER_SPLASH "${CMAKE_INSTALL_DATADIR}/icons/lomiri-barcode-reader-app-splash.png")
    install(FILES assets/lomiri-camera-app.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
    install(FILES assets/lomiri-camera-app-splash.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
    install(FILES assets/lomiri-barcode-reader-app.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
    install(FILES assets/lomiri-barcode-reader-app-splash.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)

    add_definitions("-DCLICK_MODE=1")

    if(NOT SOURCE)
        execute_process(
            COMMAND git remote -v
            COMMAND grep origin
            COMMAND grep push
            COMMAND awk "{print $2}"
            OUTPUT_VARIABLE SOURCE
            RESULT_VARIABLE res
            WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
            OUTPUT_STRIP_TRAILING_WHITESPACE
        )
      message("-- Setting SOURCE to ${SOURCE} with result of : ${res}")
    endif(NOT SOURCE)

    if(NOT SOURCE)
        set(SOURCE lp:${APP_HARDCODE})
        message("-- Setting SOURCE to ${SOURCE}")
    endif(NOT SOURCE)

else(CLICK_MODE)
    set(CAMERA_APP_DIR ${CMAKE_INSTALL_DATADIR}/${CAMERA_APP})
    set(CAMERA_ICON lomiri-camera-app)
    set(CAMERA_SPLASH ${CMAKE_INSTALL_PREFIX}/${CAMERA_APP_DIR}/lomiri-camera-app-splash.svg)

    set(READER_ICON "lomiri-barcode-reader-app")
    set(READER_SPLASH "${CMAKE_INSTALL_PREFIX}/${CAMERA_APP_DIR}/lomiri-barcode-reader-app-splash.png")
    set(PLUGIN_BASE ${CMAKE_INSTALL_LIBDIR}/${CAMERA_APP})
    set(PLUGIN_DIR ${PLUGIN_BASE}/CameraApp)
    set(DESKTOP_EXEC ${CAMERA_APP})
endif(CLICK_MODE)

# QR scanner
set(QZXING_MULTIMEDIA ON)
add_definitions(
    -DENABLE_ENCODER_GENERIC
    -DQZXING_QML
    -DQZXING_MULTIMEDIA
    -DQZXING_LIBRARY
    -DZXING_ICONV_CONST
    -DDISABLE_LIBRARY_FEATURES
    -DENABLE_DECODER_QR_CODE
    -DQ_OS_UBUNTUTOUCH
)

configure_file(config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5Quick_INCLUDE_DIRS}
    ${Qt5Multimedia_INCLUDE_DIRS}
    ${Qt5Gui_INCLUDE_DIRS}
    )

set(camera_app_HDRS
    cameraapplication.h)

set(camera_app_SRCS
    cameraapplication.cpp
    main.cpp)

add_executable(${CAMERA_APP}
    ${cameraapplication_MOC_SRCS}
    ${camera_app_SRCS}
    )

target_link_libraries(${CAMERA_APP}
    ${Qt5Core_LIBRARIES}
    ${Qt5Quick_LIBRARIES}
    ${Qt5Multimedia_LIBRARIES}
    ${Qt5Gui_LIBRARIES}
    stdc++
    qzxing
    )

install(TARGETS ${CAMERA_APP}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    )

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")

file(GLOB QML_JS_FILES *.qml *.js *.png *.svg)

install(FILES ${QML_JS_FILES}
    DESTINATION ${CAMERA_APP_DIR}
    )
set(QML_DIR qml)
install(DIRECTORY ${QML_DIR}
    DESTINATION ${CAMERA_APP_DIR}
    )


set(ASSETS_DIR assets)


install(DIRECTORY ${ASSETS_DIR}
    DESTINATION ${CAMERA_APP_DIR}
    )

install(DIRECTORY ${THEME_DIR}
    DESTINATION ${CAMERA_APP_DIR}
    )

configure_file(${DESKTOP_FILE}.in.in ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in)
add_custom_target(${DESKTOP_FILE} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE}"
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
            --desktop --template=${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}.in
            -o ${DESKTOP_FILE}
            -d ${CMAKE_SOURCE_DIR}/po
    )

configure_file(${DESKTOP_FILE_READER}.in.in ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE_READER}.in)
add_custom_target(${DESKTOP_FILE_READER} ALL
    COMMENT "Merging translations into ${DESKTOP_FILE_READER}"
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE}
            --desktop --template=${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE_READER}.in
            -o ${DESKTOP_FILE_READER}
            -d ${CMAKE_SOURCE_DIR}/po
        )

# make non compiled files visible in qtcreator
file(GLOB_RECURSE NON_COMPILED_FILES *.qml *.js *.py *.svg *.png *.in *.json *.desktop *.pot *.apparmor qmldir)
add_custom_target(NON_COMPILED_TARGET ALL SOURCES ${NON_COMPILED_FILES})

if(CLICK_MODE)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}
        DESTINATION ${CMAKE_INSTALL_PREFIX})
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE_READER}
        DESTINATION ${CMAKE_INSTALL_PREFIX})

    execute_process(
      COMMAND dpkg-architecture -qDEB_HOST_ARCH
      OUTPUT_VARIABLE CLICK_ARCH
      OUTPUT_STRIP_TRAILING_WHITESPACE
    )

    configure_file(manifest.json.in ${CMAKE_CURRENT_BINARY_DIR}/manifest.json)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json
            DESTINATION ${CMAKE_INSTALL_PREFIX})
    install(FILES camera.apparmor
            DESTINATION ${CMAKE_INSTALL_PREFIX})
    install(FILES camera-contenthub.json
            DESTINATION ${CMAKE_INSTALL_PREFIX})
    install(FILES barcode-reader.apparmor
            DESTINATION ${CMAKE_INSTALL_PREFIX})

else(CLICK_MODE)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE_READER}
        DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
endif(CLICK_MODE)

add_subdirectory(CameraApp)
add_subdirectory(desktop)

# for dh_translations to extract the domain
# (regarding syntax consistency, see http://pad.lv/1181187)
set (GETTEXT_PACKAGE "lomiri-camera-app")

add_subdirectory(po)

enable_testing()
add_subdirectory(tests)

=== debian/changelog ===
lomiri-camera-app (4.0.1+dfsg-2) unstable; urgency=medium

  * debian/control:
    + Drop libgles2-dev from B-D.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 05 Feb 2023 10:59:11 +0100

lomiri-camera-app (4.0.1+dfsg-1) unstable; urgency=medium

  * New upstream release. Upload to unstable.
  * debian/watch:
    + Start watching upstream releases.
  * debian/rules:
    + Drop no-op dh_install override.
  * debian/control:
    + Drop alternative B-D 'libgles2-mesa-dev | libgles2-dev'. Only B-D on
      libgles2-dev. Thanks, lintian.
    + Uncomment B-D: qml-module-lomiri-action.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 04 Feb 2023 23:28:06 +0100

lomiri-camera-app (4.0.0+git20230203.a8fdcf1+dfsg-1) experimental; urgency=medium

  * Initial upload to Debian. (Closes: #1030036).

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 18 Jan 2023 11:05:04 +0100

=== debian/control ===
Source: lomiri-camera-app
Section: misc
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
           Marius Gripsgard <marius@ubports.com>,
Build-Depends: cmake,
               debhelper-compat (= 13),
               libgl1-mesa-dev | libgl1-dev,
               pkg-config,
               qtbase5-dev,
               qtquickcontrols2-5-dev,
               qtdeclarative5-dev,
               qml-module-qtquick2,
               qml-module-qtpositioning,
               qml-module-qt-labs-settings,
               qml-module-qttest,
               qml-module-lomiri-components,
               qml-module-lomiri-thumbnailer,
               qml-module-lomiri-action,
               qml-module-usermetrics,
               qml-module-lomiri-content,
               qtmultimedia5-dev,
               libqt5svg5-dev,
               libusermetricsinput-dev,
               libexiv2-dev,
               libqzxing-dev,
               gettext,
               xauth,
               xvfb,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/apps/lomiri-camera-app
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-camera-app
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-camera-app.git

Package: lomiri-camera-app
Architecture: any
Depends: libqt5multimedia5,
         qml-module-qtquick2,
         qml-module-qtmultimedia | qml-module-qtmultimedia-gles,
         qml-module-lomiri-components,
         qml-module-lomiri-action,
         qml-module-qtquick-window2,
         qml-module-usermetrics,
         qml-module-lomiri-content,
         qml-module-lomiri-thumbnailer,
         qml-module-qtpositioning,
         qml-module-qtsensors,
         qml-module-qzxing,
         qml-module-lomiri-components-extras,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Camera and Barcode Scanner App for Lomiri Operating Environment
 This app is a core app for Ubuntu Touch's shell Lomiri. Ubuntu Touch is
 a mobile OS developed by the UBports Foundation. Lomiri is its operating
 environment optimized for touch based human-machine interaction, but
 also supports convergence (i.e. switching between tablet/phone and
 desktop mode).
 .
 This package provides Lomiri's Camera App and additionally also its
 Barcode Scanner App.

## lomiri-camera-app 4.0.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-camera-app VERSION 4.0.1 LANGUAGES CXX)
+project(lomiri-camera-app VERSION 4.0.2 LANGUAGES CXX)
 set (CMAKE_CXX_STANDARD 11)
 
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

=== po/CMakeLists.txt ===
project(lomiri-camera-app-translations)

include(FindGettext)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

set(DOMAIN ${GETTEXT_PACKAGE})
set(POT_FILE ${DOMAIN}.pot)

file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS LINGUAS
     REGEX "^[^#].*")
string(REGEX MATCHALL "[^ \t]+" LANGS "${LINGUAS}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in
               ${CMAKE_CURRENT_BINARY_DIR}/POTFILES COPYONLY
)

add_custom_target(${POT_FILE} ALL
                  COMMENT "Generating translation template"
                  # Extract the translatable messages from the desktop file
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --language=Desktop
                          --package-name='${GETTEXT_PACKAGE}'
                          --copyright-holder='Canonical Ltd.'
                          -D ${CMAKE_BINARY_DIR}
                          ${DESKTOP_FILE}.in
                  COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                          --from-code=UTF-8
                          --c++ --qt
                          --add-comments=TRANSLATORS
                          --keyword=tr
                          --keyword=N_
                          --keyword=tr:1,2
                          --keyword=QT_TR_NOOP
                          --keyword=tag
                          --package-name='${PROJECT_NAME}'
                          --copyright-holder='Canonical Ltd.'
                          -D ${CMAKE_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_SOURCE_DIR}
                          -D ${CMAKE_CURRENT_BINARY_DIR}
                          --join-existing
                          --files-from=${CMAKE_CURRENT_BINARY_DIR}/POTFILES)

foreach(LANG ${LANGS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${LANG}.po
                   ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.po
                   COPYONLY)
endforeach(LANG)
gettext_process_pot_file(${POT_FILE} ALL
                         INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
                         LANGUAGES ${LANGS})

=== debian/changelog ===
lomiri-camera-app (4.0.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Slight UI change in barcode reader app.
    - Translation updates.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 01 Mar 2023 09:08:25 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DPKG_GENSYMBOLS_CHECK_LEVEL=4

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

%:
	dh $@

# Skip tests on the archs they are known to be flaky with current configuration
testskip_architectures := arm64 powerpc

override_dh_auto_test:
ifneq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(testskip_architectures)))
	dh_auto_test
endif

override_dh_auto_configure:
	dh_auto_configure -- -DCLICK_MODE=OFF

override_dh_missing:
	dh_missing --fail-missing

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## lomiri-camera-app 4.0.5+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-camera-app VERSION 4.0.2 LANGUAGES CXX)
+project(lomiri-camera-app VERSION 4.0.5 LANGUAGES CXX)
 set (CMAKE_CXX_STANDARD 11)
 
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
@@ -43,7 +43,7 @@
     set(CMAKE_INSTALL_BINDIR /)
     set(PLUGIN_BASE lib/${CMAKE_LIBRARY_ARCHITECTURE})
     set(PLUGIN_DIR ${PLUGIN_BASE}/CameraApp)
-    set(DESKTOP_EXEC "./${CAMERA_APP}")
+    set(DESKTOP_EXEC "lomiri-camera-app-migrate.py ${CAMERA_APP}")
     set(CAMERA_ICON "${CMAKE_INSTALL_DATADIR}/icons/lomiri-camera-app.svg")
     set(CAMERA_SPLASH "${CMAKE_INSTALL_DATADIR}/icons/lomiri-camera-app-splash.svg")
     install(FILES assets/lomiri-camera-app.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
@@ -89,6 +89,8 @@
     set(DESKTOP_EXEC ${CAMERA_APP})
 endif(CLICK_MODE)
 
+install(PROGRAMS lomiri-camera-app-migrate.py DESTINATION "${CMAKE_INSTALL_PREFIX}/${CAMERA_APP_DIR}")
+
 # QR scanner
 set(QZXING_MULTIMEDIA ON)
 add_definitions(

=== desktop/CMakeLists.txt ===
install(DIRECTORY icons/hicolor DESTINATION DESTINATION
        ${CMAKE_INSTALL_DATADIR}/icons FILES_MATCHING PATTERN *.png)

=== tests/unittests/CMakeLists.txt ===
find_program(XVFB_RUN_BIN
    NAMES xvfb-run
)

set(XVFB_RUN_CMD ${XVFB_RUN_BIN} -a -s "-screen 0 1024x768x24")

add_executable(tst_QmlTests tst_QmlTests.cpp)
qt5_use_modules(tst_QmlTests Core Qml Quick Test QuickTest)
target_link_libraries(tst_QmlTests ${TPL_QT5_LIBRARIES})
add_test(tst_QmlTests ${XVFB_RUN_CMD} ${CMAKE_CURRENT_BINARY_DIR}/tst_QmlTests -import ${CMAKE_SOURCE_DIR} -import ${CMAKE_BINARY_DIR})

# copy qml test files to build dir
file(GLOB qmlTestFiles RELATIVE ${CMAKE_SOURCE_DIR}/tests/unittests/ *qml)
foreach(qmlTestFile ${qmlTestFiles})
  file(COPY ${qmlTestFile} DESTINATION ${CMAKE_BINARY_DIR}/tests/unittests/)
endforeach(qmlTestFile)

if(NOT CTEST_TESTING_TIMEOUT)
    set(CTEST_TESTING_TIMEOUT 60)
endif()

include_directories(
    ${CMAKE_BINARY_DIR}
    ${camera_plugin_SOURCE_DIR}
    )

add_executable(tst_storagemonitor
    tst_storagemonitor.cpp
    ${camera_plugin_SOURCE_DIR}/storagemonitor.cpp
    qstorageinfo_stub.cpp
    storageinfocontrol.cpp
    )

qt5_use_modules(tst_storagemonitor Widgets Core Quick Qml Test)
add_test(tst_storagemonitor tst_storagemonitor -xunitxml -o test.xml)
add_test(flake8 python3 -m flake8 ${CMAKE_SOURCE_DIR}/tests/autopilot)
set_tests_properties(tst_storagemonitor PROPERTIES
    TIMEOUT ${CTEST_TESTING_TIMEOUT}
    ENVIRONMENT "QT_QPA_PLATFORM=minimal"
    )

target_link_libraries(tst_storagemonitor
    camera-qml
    stdc++
)

=== debian/changelog ===
lomiri-camera-app (4.0.5+dfsg-1build1) noble; urgency=high

  * No change rebuild against libqt5gui5t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:39:01 +0100

lomiri-camera-app (4.0.5+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update copyright attribution for debian/.
    + Update copyright attributions.
  * debian/control:
    + Switch B-D from libgl1-mesa-dev to libgl-dev.
  * debian/rules:
    + Remove not needed migration script (Ubuntu Touch specific).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 05 Feb 2024 00:53:09 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: lomiri-camera-app
 Section: misc
 Priority: optional
-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders: Mike Gabriel <sunweaver@debian.org>,
            Marius Gripsgard <marius@ubports.com>,
 Build-Depends: cmake,
                debhelper-compat (= 13),
-               libgl1-mesa-dev | libgl1-dev,
+               libgl-dev,
                pkg-config,
                qtbase5-dev,
                qtquickcontrols2-5-dev,

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,10 @@
 override_dh_auto_configure:
 	dh_auto_configure -- -DCLICK_MODE=OFF
 
+override_dh_install:
+	rm debian/lomiri-camera-app/usr/share/lomiri-camera-app/lomiri-camera-app-migrate.py
+	dh_install
+
 override_dh_missing:
 	dh_missing --fail-missing

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg, dversionmangle=s/\+dfsg//" \
https://gitlab.com/ubports/development/apps/lomiri-camera-app/tags .*/lomiri-camera-app-v(\d\S+)\.tar\.gz

## lomiri-camera-app 4.0.6+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-camera-app VERSION 4.0.5 LANGUAGES CXX)
+project(lomiri-camera-app VERSION 4.0.6 LANGUAGES CXX)
 set (CMAKE_CXX_STANDARD 11)
 
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

=== debian/changelog ===
lomiri-camera-app (4.0.6+dfsg-2build1) plucky; urgency=medium

  * No-change rebuild for libexiv2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 01 Nov 2024 12:13:18 +0000

lomiri-camera-app (4.0.6+dfsg-2) unstable; urgency=medium

  * debian/rules:
    + Add mips64el architecture to testskip_architectures. (Closes: #1081960).
    + Run unit tests on testskip_architectures, but don't expect them to
      succeed. (This allows us to check from time to time if unit tests have
      become more stable on those archs).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 22 Sep 2024 12:56:00 +0200

lomiri-camera-app (4.0.6+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version to 4.7.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 14 Jun 2024 09:52:13 +0200

## lomiri-camera-app 4.0.7+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-camera-app VERSION 4.0.6 LANGUAGES CXX)
+project(lomiri-camera-app VERSION 4.0.7 LANGUAGES CXX)
 set (CMAKE_CXX_STANDARD 11)
 
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
@@ -13,12 +13,49 @@
 # Standard install paths. Needs to be set before finding packages.
 include(GNUInstallDirs)
 
+find_package(PkgConfig)
 find_package(Qt5Qml)
 find_package(Qt5Quick)
 find_package(Qt5Multimedia)
 find_package(Qt5Gui)
 find_package(Qt5Svg)
 find_package(Qt5QuickControls2)
+
+if(PkgConfig_FOUND)
+    pkg_check_modules(QZXING QZXing)
+endif()
+
+if(NOT QZXING_FOUND)
+    message(WARNING "No QZXing package config found, will try to detect it.")
+    list(APPEND QZXING_LIBRARY_DIRS "")
+
+    # Not used for anything in this codebase?
+    list(APPEND QZXING_CFLAGS_OTHER
+        -DENABLE_ENCODER_GENERIC
+        -DQZXING_QML
+        -DQZXING_MULTIMEDIA
+        -DQZXING_LIBRARY
+        -DZXING_ICONV_CONST
+        -DDISABLE_LIBRARY_FEATURES
+        -DENABLE_DECODER_QR_CODE
+        -DQ_OS_UBUNTUTOUCH
+    )
+
+    # Exact name depends on what was used to build it (QMake or CMake)
+    find_library(QZXING_LIBRARIES NAMES QZXing qzxing)
+    message(STATUS "QZXING_LIBRARIES: ${QZXING_LIBRARIES}")
+
+    # Exact path depends on what was used to build it (QMake or CMake)
+    find_path(QZXING_INCLUDE_DIRS QZXing.h PATH_SUFFIXES qzxing)
+    message(STATUS "QZXING_INCLUDE_DIRS: ${QZXING_INCLUDE_DIRS}")
+
+    if(NOT QZXING_LIBRARIES)
+        message(FATAL_ERROR "Could not find QZXing library")
+    endif()
+    if(NOT QZXING_INCLUDE_DIRS)
+        message(FATAL_ERROR "Could not find QZXing headers")
+    endif()
+endif()
 
 include(FindGettext)
 if(NOT GETTEXT_FOUND)
@@ -41,7 +78,7 @@
     set(CMAKE_INSTALL_PREFIX /)
     set(CAMERA_APP_DIR /)
     set(CMAKE_INSTALL_BINDIR /)
-    set(PLUGIN_BASE lib/${CMAKE_LIBRARY_ARCHITECTURE})
+    set(PLUGIN_BASE ${CMAKE_INSTALL_FULL_LIBDIR}/${CMAKE_LIBRARY_ARCHITECTURE})
     set(PLUGIN_DIR ${PLUGIN_BASE}/CameraApp)
     set(DESKTOP_EXEC "lomiri-camera-app-migrate.py ${CAMERA_APP}")
     set(CAMERA_ICON "${CMAKE_INSTALL_DATADIR}/icons/lomiri-camera-app.svg")
@@ -49,12 +86,12 @@
     install(FILES assets/lomiri-camera-app.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
     install(FILES assets/lomiri-camera-app-splash.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
 
-    set(READER_ICON "${CMAKE_INSTALL_DATADIR}/icons/lomiri-barcode-reader-app.png")
-    set(READER_SPLASH "${CMAKE_INSTALL_DATADIR}/icons/lomiri-barcode-reader-app-splash.png")
+    set(READER_ICON "${CMAKE_INSTALL_DATADIR}/icons/lomiri-barcode-reader-app.svg")
+    set(READER_SPLASH "${CMAKE_INSTALL_DATADIR}/icons/lomiri-barcode-reader-app-splash.svg")
     install(FILES assets/lomiri-camera-app.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
     install(FILES assets/lomiri-camera-app-splash.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
-    install(FILES assets/lomiri-barcode-reader-app.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
-    install(FILES assets/lomiri-barcode-reader-app-splash.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
+    install(FILES assets/lomiri-barcode-reader-app.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
+    install(FILES assets/lomiri-barcode-reader-app-splash.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons)
 
     add_definitions("-DCLICK_MODE=1")
 
@@ -78,30 +115,24 @@
     endif(NOT SOURCE)
 
 else(CLICK_MODE)
-    set(CAMERA_APP_DIR ${CMAKE_INSTALL_DATADIR}/${CAMERA_APP})
+    set(CAMERA_APP_DIR ${CMAKE_INSTALL_FULL_DATADIR}/${CAMERA_APP})
     set(CAMERA_ICON lomiri-camera-app)
-    set(CAMERA_SPLASH ${CMAKE_INSTALL_PREFIX}/${CAMERA_APP_DIR}/lomiri-camera-app-splash.svg)
+    set(CAMERA_SPLASH ${CAMERA_APP_DIR}/assets/lomiri-camera-app-splash.svg)
+    install(FILES assets/lomiri-camera-app.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
 
     set(READER_ICON "lomiri-barcode-reader-app")
-    set(READER_SPLASH "${CMAKE_INSTALL_PREFIX}/${CAMERA_APP_DIR}/lomiri-barcode-reader-app-splash.png")
-    set(PLUGIN_BASE ${CMAKE_INSTALL_LIBDIR}/${CAMERA_APP})
+    set(READER_SPLASH "${CAMERA_APP_DIR}/assets/lomiri-barcode-reader-app-splash.svg")
+    install(FILES assets/lomiri-barcode-reader-app.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
+
+    set(PLUGIN_BASE ${CMAKE_INSTALL_FULL_LIBDIR}/${CAMERA_APP})
     set(PLUGIN_DIR ${PLUGIN_BASE}/CameraApp)
     set(DESKTOP_EXEC ${CAMERA_APP})
 endif(CLICK_MODE)
 
-install(PROGRAMS lomiri-camera-app-migrate.py DESTINATION "${CMAKE_INSTALL_PREFIX}/${CAMERA_APP_DIR}")
-
-# QR scanner
-set(QZXING_MULTIMEDIA ON)
-add_definitions(
-    -DENABLE_ENCODER_GENERIC
-    -DQZXING_QML
-    -DQZXING_MULTIMEDIA
-    -DQZXING_LIBRARY
-    -DZXING_ICONV_CONST
-    -DDISABLE_LIBRARY_FEATURES
-    -DENABLE_DECODER_QR_CODE
-    -DQ_OS_UBUNTUTOUCH
+install(PROGRAMS lomiri-camera-app-migrate.py DESTINATION "${CAMERA_APP_DIR}")
+
+add_compile_options(
+    ${QZXING_CFLAGS_OTHER}
 )
 
 configure_file(config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)
@@ -113,6 +144,7 @@
     ${Qt5Quick_INCLUDE_DIRS}
     ${Qt5Multimedia_INCLUDE_DIRS}
     ${Qt5Gui_INCLUDE_DIRS}
+    ${QZXING_INCLUDE_DIRS}
     )
 
 set(camera_app_HDRS
@@ -126,6 +158,11 @@
     ${cameraapplication_MOC_SRCS}
     ${camera_app_SRCS}
     )
+
+target_link_directories(${CAMERA_APP}
+    PUBLIC
+    ${QZXING_LIBRARY_DIRS}
+)
 
 target_link_libraries(${CAMERA_APP}
     ${Qt5Core_LIBRARIES}
@@ -133,7 +170,7 @@
     ${Qt5Multimedia_LIBRARIES}
     ${Qt5Gui_LIBRARIES}
     stdc++
-    qzxing
+    ${QZXING_LIBRARIES}
     )
 
 install(TARGETS ${CAMERA_APP}
@@ -225,5 +262,7 @@
 
 add_subdirectory(po)
 
-enable_testing()
-add_subdirectory(tests)
+include(CTest)
+if(BUILD_TESTING)
+    add_subdirectory(tests)
+endif()

=== debian/changelog ===
lomiri-camera-app (4.0.7+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Trivially rebase 2001_no-autopilot-on-Debian.patch.
    + Add 1001_content-hub-for-non-click-builds.patch. Fix missing content-hub
      integration for non-click builds.
  * debian/copyright:
    + Update attributions for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 31 Jan 2025 22:54:46 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: lomiri-camera-app
 Section: misc
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders: Mike Gabriel <sunweaver@debian.org>,
            Marius Gripsgard <marius@ubports.com>,
 Build-Depends: cmake,
@@ -29,7 +28,7 @@
                gettext,
                xauth,
                xvfb,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/apps/lomiri-camera-app
 Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-camera-app

## lomiri-camera-app 4.0.8%2Bdfsg

=== po/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
                           --package-name='${GETTEXT_PACKAGE}'
                           --copyright-holder='Canonical Ltd.'
                           -D ${CMAKE_BINARY_DIR}
-                          ${DESKTOP_FILE}.in
+                          ${DESKTOP_FILE}.in ${DESKTOP_FILE_READER}.in
                   COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${POT_FILE}
                           --from-code=UTF-8
                           --c++ --qt

## lomiri-camera-app 4.0.8+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-camera-app VERSION 4.0.7 LANGUAGES CXX)
+project(lomiri-camera-app VERSION 4.0.8 LANGUAGES CXX)
 set (CMAKE_CXX_STANDARD 11)
 
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
@@ -251,6 +251,9 @@
         DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
     install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_FILE_READER}
         DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
+    install(FILES camera-contenthub.json
+            DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-content-hub/peers
+            RENAME lomiri-camera-app)
 endif(CLICK_MODE)
 
 add_subdirectory(CameraApp)

=== debian/changelog ===
lomiri-camera-app (4.0.8+dfsg-5) unstable; urgency=medium

  * debian/patches:
    + Add 0006_qml-Viewfinder-fix-content-export-preview-corruption.patch.
      qml/Viewfinder: Fix content export preview corruption in !hasEXIF mode.
    + Add 0007_qml-Support-scanning-white-QR-codes-in-BarcodeReaderApp.patch.
      Support white QR codes in barcode reader app.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 15 Jun 2025 21:14:56 +0200

lomiri-camera-app (4.0.8+dfsg-4) unstable; urgency=medium

  * debian/patches:
    + Add 0002_fix-image-quality-on-app-startup.patch. Correctly initialize
      image resolution on app startup. (Closes: #1105112).
    + Add 0003_fix-spelling-of-background-color-in-AdvancedOptions-qml.patch.
      AdvancedOptions.qml: Fix typo in theme palette name. (Closes: #1106850).
    + Add 0004_Save-orientation-when-erasing-metadata.patch. Fix privacy mode
      (where no EXIF data is stored in images): Save orientation data also in
      privacy mode. (Closes: #1106849).
    + Add 0005_add-left-margin-between-icon-and-label-in-options-selector.patch.
      Minor UI icon fix for options selector.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 30 May 2025 16:14:07 +0200

lomiri-camera-app (4.0.8+dfsg-3) unstable; urgency=medium

  * debian/patches:
    + Add 0001_fix-recorded-video-size.patch. Fix initialization of video
      resolution. (Closes: #1104908)
  * debian/control:
    + Drop from D: qml-module-qzxing. The qzxing library does not provide a
      full QQmlEngineExtensionPlugin, it simply provides QQuickImageProvider.
      Trying to import the QML module will fail. This goes together with the
      removal of the qml-module-qzxing bin:pkg from src:pkg qzxing. (Closes:
      #1092953).
    + Switch from pkg-config => pkgconf. Thanks, lintian.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 10 May 2025 16:04:19 +0200

lomiri-camera-app (4.0.8+dfsg-2) unstable; urgency=medium

  * debian/patches:
    + Update 2002_hide-app-if-not-in-lomiri.patch. Include barcode reader app.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 05 May 2025 22:59:32 +0200

lomiri-camera-app (4.0.8+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Add 2002_hide-app-if-not-in-lomiri.patch.
    + Drop 1001_content-hub-for-non-click-builds.patch. Applied upstream.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/copyright:
    + Fix FSF mailing address.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 05 May 2025 13:25:12 +0200

=== debian/rules ===
--- 
+++ 
@@ -15,9 +15,17 @@
 # Skip tests on the archs they are known to be flaky with current configuration
 testskip_architectures := arm64 powerpc
 
+# Skip tests on mips64el. The QmlTests crash with segmentation fault (not only in
+# this package) which makes one guess that there is something odd going on with the
+# QmlTest test suite... No deeper motivation to hunt this down on an architecture
+# where Lomiri et al. will probably never used on.
+testskip_architectures += mips64el
+
 override_dh_auto_test:
 ifneq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(testskip_architectures)))
 	dh_auto_test
+else
+	-dh_auto_test
 endif
 
 override_dh_auto_configure:

## lomiri-camera-app 4.1.1%2Bdfsg

=== desktop/CMakeLists.txt ===
install(DIRECTORY icons/hicolor DESTINATION
        ${CMAKE_INSTALL_DATADIR}/icons FILES_MATCHING PATTERN *.png)

## lomiri-camera-app 4.1.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.5)
-project(lomiri-camera-app VERSION 4.0.8 LANGUAGES CXX)
+project(lomiri-camera-app VERSION 4.1.1 LANGUAGES CXX)
 set (CMAKE_CXX_STANDARD 11)
 
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
@@ -64,6 +64,8 @@
 
 option(INSTALL_TESTS "Install the tests on make install" off)
 option(CLICK_MODE "Installs to a contained location" on)
+set(CLICK_VERSION "${PROJECT_VERSION}"
+    CACHE STRING "Version of built Click. Meaningful only in Click mode.")
 
 set(CAMERA_APP lomiri-camera-app)
 set(AUTOPILOT_DIR lomiri_camera_app)

=== CameraApp/CMakeLists.txt ===
# QML plugin
project(camera_plugin)

set(plugin_SRCS
    components.cpp
    advancedcamerasettings.cpp
    fileoperations.cpp
    postprocessoperations.cpp
    foldersmodel.cpp
    storagemonitor.cpp
    storagelocations.cpp
    adddatestamp.cpp
    )

set(plugin_HDRS
    components.h
    advancedcamerasettings.h
    fileoperations.h
    postprocessoperations.h
    foldersmodel.h
    storagemonitor.h
    storagelocations.h
    adddatestamp.h
    )

add_library(camera-qml SHARED ${plugin_SRCS} ${plugin_HDRS})

#make sure that the qmldir file is in the QML2_IMPORT_PATH when running from QtC
file(COPY qmldir DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

target_link_libraries(camera-qml
    ${Qt5Qml_LIBRARIES}
    ${Qt5Quick_LIBRARIES}
    ${Qt5Multimedia_LIBRARIES}
    exiv2
    )

install(TARGETS camera-qml DESTINATION ${PLUGIN_DIR})
install(FILES qmldir DESTINATION ${PLUGIN_DIR})

=== tests/CMakeLists.txt ===
add_subdirectory(autopilot)
add_subdirectory(unittests)

=== tests/unittests/CMakeLists.txt ===
--- 
+++ 
@@ -4,9 +4,18 @@
 
 set(XVFB_RUN_CMD ${XVFB_RUN_BIN} -a -s "-screen 0 1024x768x24")
 
+find_package(Qt5Test REQUIRED)
+find_package(Qt5QuickTest REQUIRED)
+
 add_executable(tst_QmlTests tst_QmlTests.cpp)
-qt5_use_modules(tst_QmlTests Core Qml Quick Test QuickTest)
-target_link_libraries(tst_QmlTests ${TPL_QT5_LIBRARIES})
+target_link_libraries(tst_QmlTests
+    Qt5::Core
+    Qt5::Qml
+    Qt5::Quick
+    Qt5::Test
+    Qt5::QuickTest
+    ${TPL_QT5_LIBRARIES}
+)
 add_test(tst_QmlTests ${XVFB_RUN_CMD} ${CMAKE_CURRENT_BINARY_DIR}/tst_QmlTests -import ${CMAKE_SOURCE_DIR} -import ${CMAKE_BINARY_DIR})
 
 # copy qml test files to build dir
@@ -31,7 +40,6 @@
     storageinfocontrol.cpp
     )
 
-qt5_use_modules(tst_storagemonitor Widgets Core Quick Qml Test)
 add_test(tst_storagemonitor tst_storagemonitor -xunitxml -o test.xml)
 add_test(flake8 python3 -m flake8 ${CMAKE_SOURCE_DIR}/tests/autopilot)
 set_tests_properties(tst_storagemonitor PROPERTIES
@@ -40,6 +48,11 @@
     )
 
 target_link_libraries(tst_storagemonitor
+    Qt5::Core
+    Qt5::Quick
+    Qt5::Qml
+    Qt5::Test
+    Qt5::Widgets
     camera-qml
     stdc++
 )

=== debian/changelog ===
lomiri-camera-app (4.1.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop patches 0001 - 0007. All originally cherry-picked from upstream and
      included in this release.
    + Add 2003_adapt-import-paths-in-unittests.patch. Adjust import paths in
      unit tests so new .qml files can be found after source tree restructuring
      by upstream.
  * debian/copyright:
    + Update copyright attributions (after files got moved around by upstream).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 11 Aug 2025 23:34:08 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libgl-dev,
-               pkg-config,
+               pkgconf,
                qtbase5-dev,
                qtquickcontrols2-5-dev,
                qtdeclarative5-dev,
@@ -28,7 +28,7 @@
                gettext,
                xauth,
                xvfb,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/apps/lomiri-camera-app
 Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-camera-app
@@ -47,7 +47,6 @@
          qml-module-lomiri-thumbnailer,
          qml-module-qtpositioning,
          qml-module-qtsensors,
-         qml-module-qzxing,
          qml-module-lomiri-components-extras,
          ${misc:Depends},
          ${shlibs:Depends},
